<?php

class Menustructure extends CActiveRecord
{
	public static function model($className=__CLASS__)
	{
		return parent::model($className);
	}

	public function tableName()
	{
		return 'menustructure';
	}

	public function rules()
	{
		return array(
			array('title', 'required'),
			array('parent', 'numerical', 'integerOnly'=>true),
			array('sort, title', 'length', 'max'=>255),
			array('id, parent, sort, title', 'safe', 'on'=>'search'),
		);
	}

	public function relations()
	{
		return array(
			'sitecontent' => array(
				self::HAS_MANY,
				'Sitecontent',
				'position',
				'order' => 'sitecontent.sort'),
			'parent' => array(
				self::BELONGS_TO,
				'Menustructure',
				'parent'),
		);
	}

	public function attributeLabels()
	{
		return array(
			'id' => '#',
			'parent' => Yii::t('CmsModule.cms','Parent'),
			'sort' => Yii::t('CmsModule.cms','Sort order'),
			'title' => Yii::t('CmsModule.cms','Title'),
		);
	}

	public function search()
	{
		$criteria=new CDbCriteria;

		$criteria->compare('id',$this->id);

		$criteria->compare('parent',$this->parent);

		$criteria->compare('sort',$this->sort,true);

		$criteria->compare('title',$this->title,true);

		return new CActiveDataProvider('Menustructure', array(
			'criteria'=>$criteria,
		));
	}
}
